;**********************************************************************
;        This is a simple masm window program.            
;        It is created to use OS Version Library. 
;        Current Date: January 27, 2011            
;**********************************************************************
.486
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc    
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
;**********************************************************************
includelib \ForumVersion\SystemVersion.lib
;**********************************************************************
    CrtDataDirFile PROTO
    ChckUserSecurity PROTO
    ChckProcessrCapabilts PROTO
    ChckOperSysVersion PROTO
;**********************************************************************

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
;**********************************************************************
.data
ClassName db "GreyWndw", 0    
AppName  db "Operating System, Processor Features, and Security Context Library", 0    
MenuName db "MainMenu", 0    
;**********************************************************************
.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
;**********************************************************************
.const
IDM_TESTLIBRARY equ 3
IDM_EXIT equ 4
;**********************************************************************
.code

start:
	INVOKE GetModuleHandle, NULL
	mov    hInstance, eax
	INVOKE GetCommandLine
	mov    CommandLine, eax
	INVOKE WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	INVOKE ExitProcess, eax

;**********************************************************************
DisplayInfo PROC, dwInfo:DWORD    
          XOR eax, eax    
          RET
DisplayInfo  ENDP    

;**********************************************************************
SaveData PROC, dwData:DWORD    
          XOR eax, eax    
          RET
SaveData  ENDP    

;**********************************************************************
WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hMainWnd:HWND
            LOCAL ExtStyle:DWORD
            LOCAL WndStyle:DWORD
            LOCAL dwSpace:DWORD
            LOCAL dwWidth:DWORD    
            LOCAL dwHeight:DWORD  

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra, NULL
	mov   wc.cbWndExtra, NULL
	push  hInstance
	pop   wc.hInstance
            INVOKE GetStockObject, 2    ;  GRAY_BRUSH    
	mov   wc.hbrBackground, eax
	mov   wc.lpszMenuName, OFFSET MenuName 
	mov   wc.lpszClassName,OFFSET ClassName
	INVOKE LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, eax
	mov   wc.hIconSm, eax
	INVOKE LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, eax
	INVOKE RegisterClassEx, ADDR wc

;    Set the Extended Windows Style and the Windows Style here.    
            XOR eax, eax
;    WS_EX_TOPMOST | WS_EX_NOINHERITLAYOUT = 0x00100008  or 1048584      
            mov eax,1048584
            mov ExtStyle, eax    
            XOR eax, eax
;    WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_CLIPCHILDREN = 0xBC15F600  or  315555840    
            mov eax, 315555840
            mov  WndStyle, eax    

;    Calculate the correct x and y screen coordinates for the extended windows style here.    
            XOR ebx, ebx
            INVOKE GetSystemMetrics, SM_CXBORDER    
            mov dwSpace, eax
            mov ebx, 2
            MUL ebx
            mov ebx, 1024
            SUB ebx, eax
            mov dwWidth, ebx
            XOR ebx, ebx
            INVOKE GetSystemMetrics, SM_CYBORDER
            mov ebx, 2
            MUL ebx
            mov ebx, 768
            SUB ebx, eax
            mov dwHeight, ebx

	INVOKE CreateWindowEx, ExtStyle, ADDR ClassName, ADDR AppName, WndStyle, dwSpace, 0, dwWidth, dwHeight, NULL, NULL, hInst, NULL
	mov   hMainWnd, eax
	INVOKE ShowWindow, hMainWnd, SW_SHOWNORMAL
	INVOKE UpdateWindow, hMainWnd
	.WHILE TRUE
		INVOKE GetMessage, ADDR msg, NULL, 0, 0
		.BREAK .IF (!eax)
		INVOKE TranslateMessage, ADDR msg
		INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax, msg.wParam
	RET
WinMain ENDP

;**********************************************************************
WndProc PROC hMainWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.IF uMsg==WM_DESTROY
		INVOKE PostQuitMessage, NULL
	.ELSEIF uMsg==WM_COMMAND
		mov eax, wParam
		.IF ax==IDM_TESTLIBRARY
                        INVOKE CrtDataDirFile
                        INVOKE ChckUserSecurity 
                        INVOKE ChckProcessrCapabilts
                        INVOKE ChckOperSysVersion    
		.ELSEIF ax==IDM_EXIT
			INVOKE SendMessage, hMainWnd, WM_DESTROY, 0, 0
		.ENDIF
	.ELSE
		INVOKE DefWindowProc, hMainWnd, uMsg, wParam, lParam		
		ret
	.ENDIF
	XOR eax,eax
	RET
WndProc ENDP

;**********************************************************************
end start
;**********************************************************************


